﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Decal.Adapter.Wrappers;
using VirindiViewService;
using VirindiViewService.Controls;
using System.Windows.Forms;

namespace CompHud
{
    public partial class PluginCore
    {

        private HudView cHud;
        private HudFixedLayout cHead;

        private void createCHud()
        {
            if (inactive || pluginSettings == null) return;

            if (cHud == null)
            {
                cHud = new HudView(PLUGIN + " - Color Demo", 200, 20, new ACImage(System.Drawing.Color.Black), false);
                cHud.Alpha = pluginSettings.alpha;
                cHud.Icon = 0x64F8;
                cHud.Visible = true;
                cHud.UserGhostable = true;
                cHud.Ghosted = true;
                cHud.UserMinimizable = true;
                cHud.UserAlphaChangeable = true;
                cHud.ShowIcon = true;
                cHud.Location = new Point(150, 150);

                //cHud.LoadUserSettings();

                cHead = new HudFixedLayout();
                cHud.Controls.HeadControl = cHead;

                cHud.ThemeChanged += new EventHandler(cHud_ThemeChanged);
            }
        }

        void cHud_ThemeChanged(object sender, EventArgs e)
        {
            redrawCHud();
        }

        private void redrawCHud()
        {
            if (inactive || pluginSettings == null) return;

            if (cHud == null) createCHud();

            cHud.Visible = true;

            int h = 10;

            foreach (HudControl ctrl in cHud.Controls.ChildrenOf(cHead))
            {
                cHead.RemovedChild(ctrl);
                ctrl.Dispose();
            }

            foreach (string s in cHud.Theme.GetValList())
            {
                if (s.ToLower().Contains("color") || s.ToLower().Contains("text"))
                {
                    try
                    {
                        Color c = cHud.Theme.GetColor(s);
                        HudStaticText ax = new HudStaticText();
                        ax.FontHeight = TEXTSIZE;
                        ax.Text = s;
                        ax.TextColor = c;

                        cHead.AddControl(ax, new Rectangle(0, h, 200, LINEHEIGHT + LINEHEIGHT - TEXTSIZE));

                        h += LINEHEIGHT + LINEHEIGHT - TEXTSIZE;
                    }
                    catch (Exception ex) { };                    
                }
            }
            cHud.Height = h;
        }
    }
}
