﻿using Decal.Adapter;
using System;
using System.Collections.Generic;

namespace CompHud
{
    public partial class PluginCore : PluginBase
    {
        static string[] SPELLCOMPS_ALCH = new string[] {
            "Brimstone", "Cadmia", "Cinnabar", "Cobalt", "Colcothar", "Gypsum",
            "Quicksilver", "Realgar", "Stibnite", "Turpeth", "Verdigris", "Vitriol"
        };
        static string[] SPELLCOMPS_ALCH_PEA = new string[] {
            "Brimstone Pea", "Cadmia Pea", "Cinnabar Pea", "Cobalt Pea", "Colcothar Pea", "Gypsum Pea",
            "Quicksilver Pea", "Realgar Pea", "Stibnite Pea", "Turpeth Pea", "Verdigris Pea", "Vitriol Pea"
        };
        static string[] SPELLCOMPS_HERB = new string[] {
            "Amaranth", "Bistort", "Comfrey", "Damiana", "Dragonsblood", "Eyebright", "Frankincense", "Ginseng",
            "Hawthorn", "Henbane", "Hyssop", "Mandrake", "Mugwort", "Myrrh", "Saffron", "Vervain", "Wormwood", "Yarrow"
        };
        static string[] SPELLCOMPS_HERB_PEA = new string[] {
            "Amaranth Pea", "Bistort Pea", "Comfrey Pea", "Damiana Pea", "Dragonsblood Pea", "Eyebright Pea", "Frankincense Pea", "Ginseng Pea",
            "Hawthorn Pea", "Henbane Pea", "Hyssop Pea", "Mandrake Pea", "Mugwort Pea", "Myrrh Pea", "Saffron Pea", "Vervain Pea", "Wormwood Pea", "Yarrow Pea"
        };
        static string[] SPELLCOMPS_POWDER = new string[] {
            "Powdered Agate", "Powdered Amber", "Powdered Azurite", "Powdered Bloodstone", "Powdered Carnelian",
            "Powdered Hematite", "Powdered Lapis Lazuli", "Powdered Malachite", "Powdered Moonstone",
            "Powdered Onyx", "Powdered Quartz", "Powdered Turquoise", "Ground Chorizite"
        };
        static string[] SPELLCOMPS_POWDER_PEA = new string[] {
            "Powdered Agate Pea", "Powdered Amber Pea", "Powdered Azurite Pea", "Powdered Bloodstone Pea", "Powdered Carnelian Pea",
            "Powdered Hematite Pea", "Powdered Lapis Lazuli Pea", "Powdered Malachite Pea", "Powdered Moonstone Pea",
            "Powdered Onyx Pea", "Powdered Quartz Pea", "Powdered Turquoise Pea", "Powdered Chorizite Pea"
        };
        static string[] SPELLCOMPS_TALISMAN = new string[] {
            "Alder Talisman", "Ashwood Talisman", "Birch Talisman", "Blackthorn Talisman", "Cedar Talisman", "Ebony Talisman", "Elder Talisman",
            "Hazel Talisman", "Hemlock Talisman", "Oak Talisman", "Poplar Talisman", "Rowan Talisman", "Willow Talisman", "Yew Talisman"
        };
        static string[] SPELLCOMPS_TALISMAN_PEA = new string[] {
            "Alder Pea", "Ashwood Pea", "Birch Pea", "Blackthorn Pea", "Cedar Pea", "Ebony Pea", "Elder Pea",
            "Hazel Pea", "Hemlock Pea", "Oak Pea", "Poplar Pea", "Rowan Pea", "Willow Pea", "Yew Pea"
        };
        static string[] SPELLCOMPS_TAPER = new string[] {
            "Blue Taper", "Brown Taper", "Green Taper", "Grey Taper", "Indigo Taper", "Orange Taper", "Pink Taper",
            "Red Taper", "Turquoise Taper", "Violet Taper", "White Taper", "Yellow Taper", "Prismatic Taper"
        };
        static string[] SPELLCOMPS_TAPER_PEA = new string[] {
            "Blue Pea", "Brown Pea", "Green Pea", "Grey Pea", "Indigo Pea", "Orange Pea", "Pink Pea",
            "Red Pea", "Turquoise Pea", "Violet Pea", "White Pea", "Yellow Pea", "Prismatic Pea"
        };
        static string[] SPELLCOMPS_SCARAB = new string[] {
            "Lead Scarab", "Iron Scarab", "Copper Scarab", "Silver Scarab", "Gold Scarab", "Pyreal Scarab", "Platinum Scarab", "Diamond Scarab", "Dark Scarab", "Mana Scarab"
        };
        static string[] SPELLCOMPS_SCARAB_PEA = new string[] {
            "Lead Pea", "Iron Pea", "Copper Pea", "Silver Pea", "Gold Pea", "Pyreal Pea", "Platinum Pea", "Diamond Pea", "Dark Pyramid", "Mana Pea"
        };
        static string[] MANA_CHARGES = new string[] {
            "Great Mana Charge", "Superb Mana Charge", "Titan Mana Charge", "Major Mana Stone"
        };
        static string[] ARCHMAGES = new string[] {
            "Arqubal the Archmage", "Aun Amanaualuan the Elder Shaman", "Fadsahil al-Tashbi the Master Archmage",
            "Farnor the Archmage", "Hacha Jien the Archmage",
            "Lich Archmage", "Master Celdiseth the Archmage", "Master Shoyanen Kenchu the Archmage",
            "Raenholm the Archmage", "Sialla Jiro", "Vermilia the Archmage", "Zisaha bint Jaidka the Mage"
        };

        private static SortedDictionary<string, int> matIds;
        private static SortedDictionary<string, int> matIdsLC;
        private static SortedDictionary<int, string> matNames;
        static void GenerateMaterialInfo()
        {
            if (matIds == null)
            {
                matIds = new SortedDictionary<string, int>();
                matIds.Add("Agate", 10);
                matIds.Add("Alabaster", 66);
                matIds.Add("Amber", 11);
                matIds.Add("Amethyst", 12);
                matIds.Add("Aquamarine", 13);
                matIds.Add("Armoredillo Hide", 53);
                matIds.Add("Azurite", 14);
                matIds.Add("Black Garnet", 15);
                matIds.Add("Black Opal", 16);
                matIds.Add("Bloodstone", 17);
                matIds.Add("Brass", 57);
                matIds.Add("Bronze", 58);
                matIds.Add("Carnelian", 18);
                matIds.Add("Ceramic", 1);
                matIds.Add("Citrine", 19);
                matIds.Add("Copper", 59);
                matIds.Add("Diamond", 20);
                matIds.Add("Ebony", 73);
                matIds.Add("Emerald", 21);
                matIds.Add("Fire Opal", 22);
                matIds.Add("Gold", 60);
                matIds.Add("Granite", 67);
                matIds.Add("Green Garnet", 23);
                matIds.Add("Green Jade", 24);
                matIds.Add("Gromnie Hide", 54);
                matIds.Add("Hematite", 25);
                matIds.Add("Imperial Topaz", 26);
                matIds.Add("Iron", 61);
                matIds.Add("Ivory", 51);
                matIds.Add("Jet", 27);
                matIds.Add("Lapis Lazuli", 28);
                matIds.Add("Lavender Jade", 29);
                matIds.Add("Leather", 52);
                matIds.Add("Linen", 4);
                matIds.Add("Mahogany", 74);
                matIds.Add("Malachite", 30);
                matIds.Add("Marble", 68);
                matIds.Add("Moonstone", 31);
                matIds.Add("Oak", 75);
                matIds.Add("Obsidian", 69);
                matIds.Add("Onyx", 32);
                matIds.Add("Opal", 33);
                matIds.Add("Peridot", 34);
                matIds.Add("Pine", 76);
                matIds.Add("Porcelain", 2);
                matIds.Add("Pyreal", 62);
                matIds.Add("Red Garnet", 35);
                matIds.Add("Red Jade", 36);
                matIds.Add("Reed Shark Hide", 55);
                matIds.Add("Rose Quartz", 37);
                matIds.Add("Ruby", 38);
                matIds.Add("Sandstone", 70);
                matIds.Add("Sapphire", 39);
                matIds.Add("Satin", 5);
                matIds.Add("Serpentine", 71);
                matIds.Add("Silk", 6);
                matIds.Add("Silver", 63);
                matIds.Add("Smokey Quartz", 40);
                matIds.Add("Steel", 64);
                matIds.Add("Sunstone", 41);
                matIds.Add("Teak", 77);
                matIds.Add("Tiger Eye", 42);
                matIds.Add("Tourmaline", 43);
                matIds.Add("Turquoise", 44);
                matIds.Add("Velvet", 7);
                matIds.Add("White Jade", 45);
                matIds.Add("White Quartz", 46);
                matIds.Add("White Sapphire", 47);
                matIds.Add("Wool", 8);
                matIds.Add("Yellow Garnet", 48);
                matIds.Add("Yellow Topaz", 49);
                matIds.Add("Zircon", 50);

                matIdsLC = new SortedDictionary<string, int>();
                matNames = new SortedDictionary<int, string>();
                
                foreach (KeyValuePair<string, int> kp in matIds)
                {
                    matIdsLC[kp.Key.ToLower()] = kp.Value;
                    matNames[kp.Value] = kp.Key;
                }
            }
        }

        public static string getMaterialName(int materialId)
        {
            GenerateMaterialInfo();
            if (matNames.ContainsKey(materialId))
                return matNames[materialId];
            else
                return String.Empty;
        }

        public static int GetMaterialID(string matname)
        {
            GenerateMaterialInfo();
            if (matIds.ContainsKey(matname))
                return matIds[matname];
            else if (matIdsLC.ContainsKey(matname.ToLower()))
                return matIdsLC[matname.ToLower()];
            else 
                return 0;
        }
    }
}